% Jacobian_uv 
%
%       Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua
%       Pose Priors for Simultaneously Solving Alignment and Correspondence
%       European Conference on Computer Vision (ECCV), 2008
%
% Copyright (C) <2009>  <Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua>
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Francesc Moreno-Noguer, Institut de Robtica i Informtica Industrial (CSIC/UPC), May 2009.
% fmoreno@iri.upc.edu, http://www-iri.upc.es/people/fmoreno/

function J=Jacobian_uv(A,x,y,z)

num_u=A(1,1)*x+A(1,2)*y+A(1,3)*z;
num_v=A(2,1)*x+A(2,2)*y+A(2,3)*z;
den=A(3,1)*x+A(3,2)*y+A(3,3)*z;

J=zeros(2,3);

J(1,1)=(A(1,1)*den-A(3,1)*num_u)/(den^2);
J(1,2)=(A(1,2)*den-A(3,2)*num_u)/(den^2);
J(1,3)=(A(1,3)*den-A(3,3)*num_u)/(den^2);

J(2,1)=(A(2,1)*den-A(3,1)*num_v)/(den^2);
J(2,2)=(A(2,2)*den-A(3,2)*num_v)/(den^2);
J(2,3)=(A(2,3)*den-A(3,3)*num_v)/(den^2);
