% find_candidate_points 
%
%       Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua
%       Pose Priors for Simultaneously Solving Alignment and Correspondence
%       European Conference on Computer Vision (ECCV), 2008
%
% Copyright (C) <2009>  <Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua>
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Francesc Moreno-Noguer, Institut de Robtica i Informtica Industrial (CSIC/UPC), May 2009.
% fmoreno@iri.upc.edu, http://www-iri.upc.es/people/fmoreno/


function [candidates1,Ui1,Xi1,idx2consider,idx1]=find_candidate_points(Xss,U,Uproj,covariance_uv,threshold_mah,threshold_eucl,idx2consider)

npointsin=zeros(size(idx2consider));
for n1=idx2consider
    point(n1).idx_points_close=find_points_low_mah_eucl_distance(U,Uproj(n1,:),covariance_uv(:,:,n1),threshold_mah,threshold_eucl);
    npointsin(n1)=size(point(n1).idx_points_close,2);
end

%remove from list points with zero candidates
zer=find(npointsin(idx2consider)==0);
idx2consider2=remove_from_list(idx2consider,zer);

if size(idx2consider2,2)>0
    %select the point with smaller number of points within the thresholdxsigma ellipse
    [nidx1,idx1_]=min(npointsin(idx2consider2));
    idx1=idx2consider2(idx1_);
    Ui1=Uproj(idx1,:);
    Xi1=Xss(idx1,:);
    candidates1=point(idx1).idx_points_close;
    rm=find(idx2consider==idx1);
    idx2consider=remove_from_list(idx2consider,rm);
    
else %no candidates
    Ui1=[];
    Xi1=[];
    candidates1=[];
    idx1=[];
end





