% rodrigues2mat 
%
%       Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua
%       Pose Priors for Simultaneously Solving Alignment and Correspondence
%       European Conference on Computer Vision (ECCV), 2008
%
% Copyright (C) <2009>  <Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua>
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Francesc Moreno-Noguer, Institut de Robtica i Informtica Industrial (CSIC/UPC), May 2009.
% fmoreno@iri.upc.edu, http://www-iri.upc.es/people/fmoreno/

function R=rodrigues2mat(wx,wy,wz)

theta = sqrt(wx*wx+wy*wy+wz*wz);

a = cos(theta);
b = (1-cos(theta))/(theta^2);
c = sin(theta)/theta;

R(1,1) = a + b*(wx^2);
R(1,2) = b*wx*wy - c*wz;
R(1,3) = b*wx*wz + c*wy;

R(2,1) = b*wx*wy + c*wz;
R(2,2) = a + b*(wy^2);
R(2,3) = b*wy*wz - c*wx;

R(3,1) = b*wx*wz - c*wy;
R(3,2) = b*wz*wy + c*wx;
R(3,3) = a + b*(wz^2);