% project_points2 
%
%       Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua
%       Pose Priors for Simultaneously Solving Alignment and Correspondence
%       European Conference on Computer Vision (ECCV), 2008
%
% Copyright (C) <2009>  <Francesc Moreno-Noguer, Vincent Lepetit, Pascal Fua>
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the version 3 of the GNU General Public License
% as published by the Free Software Foundation.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
% General Public License for more details.       
% You should have received a copy of the GNU General Public License
% along with this program. If not, see <http://www.gnu.org/licenses/>.
%
% Francesc Moreno-Noguer, Institut de Robtica i Informtica Industrial (CSIC/UPC), May 2009.
% fmoreno@iri.upc.edu, http://www-iri.upc.es/people/fmoreno/

function [Up,R,T,Xc]=project_points2(A,Pose,Xw)

wx=Pose(1); wy=Pose(2); wz=Pose(3);
Tx=Pose(4); Ty=Pose(5); Tz=Pose(6);
R=rodrigues2mat(wx,wy,wz);
T=[Tx,Ty,Tz]';

npoints=size(Xw,1);

Xc=R*Xw'+repmat(T,[1,npoints]);

Uph=A*Xc;

Up(1,:)=Uph(1,:)./Uph(3,:);
Up(2,:)=Uph(2,:)./Uph(3,:);
Up=Up';



